From de5340ec856ffa78f80dcf85831135de5350084b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:18 +0000
Subject: [PATCH 446/2232] Test returning CxxVector by reference from C to Rust


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 750b30e..4a6ec81 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -31,6 +31,7 @@ pub mod ffi {
         fn c_return_unique_ptr_vector_f64() -> UniquePtr<CxxVector<f64>>;
         fn c_return_unique_ptr_vector_shared() -> UniquePtr<CxxVector<Shared>>;
         fn c_return_unique_ptr_vector_opaque() -> UniquePtr<CxxVector<C>>;
+        fn c_return_ref_vector(c: &C) -> &CxxVector<u8>;
 
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 04f5168..8503ac7 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -28,6 +28,8 @@ size_t C::set2(size_t n) {
   return this->n;
 }
 
+const std::vector<uint8_t> &C::get_v() const { return this->v; }
+
 size_t c_return_primitive() { return 2020; }
 
 Shared c_return_shared() { return Shared{2020}; }
@@ -87,6 +89,10 @@ std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque() {
   return std::unique_ptr<std::vector<C>>(new std::vector<C>());
 }
 
+const std::vector<uint8_t> &c_return_ref_vector(const C &c) {
+  return c.get_v();
+}
+
 void c_take_primitive(size_t n) {
   if (n == 2020) {
     cxx_test_suite_set_correct();
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 2c7428d..0e9081a 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -15,9 +15,11 @@ public:
   size_t set(size_t n);
   size_t get2() const;
   size_t set2(size_t n);
+  const std::vector<uint8_t> &get_v() const;
 
 private:
   size_t n;
+  std::vector<uint8_t> v;
 };
 
 size_t c_return_primitive();
@@ -33,6 +35,7 @@ std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8();
 std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64();
 std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared();
 std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque();
+const std::vector<uint8_t> &c_return_ref_vector(const C &c);
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);

